<script lang="ts">
	import { getContext } from "svelte"
	import queryString from "query-string"
	import { goto } from "$app/navigation"
	import { page, session } from "$app/stores"
	import { AUTH_CONTEXT_KEY } from "$lib/constants"
	// import BackendSelect from "$lib/components/BackendSelect.svelte"
	import ProjectLoader from "$lib/components/ProjectLoader.svelte"
	import ProjectSelector from "$lib/components/ProjectSelector.svelte"
	import { userProfile } from "$lib/stores"
	import { browser } from "$app/env"

	let storageAdapter

	const { gotoLoginIfAnonymous, tokens } = getContext(AUTH_CONTEXT_KEY)
	gotoLoginIfAnonymous($page)
	$: if (browser && $tokens && $userProfile) {
		fetchInitialData($session, $tokens, $userProfile)
	}

	async function fetchInitialData(session, tokens, userProfile) {
		const GitLabStorageAdapter = (await import("$lib/infrastructure/storage-adapter/gitlab")).default
		storageAdapter = GitLabStorageAdapter.create(session.config, tokens, userProfile)
	}

	function handleProjectSelect(event) {
		const project = event.detail
		goto(
			queryString.stringifyUrl({
				url: "/data-packages/view",
				query: {
					project: project.name,
				},
			})
		)
	}
</script>

<h1>Data packages</h1>

<div class="my-8">
	<a class="btn btn-primary" href="/data-packages/new">New Data Package</a>
</div>

{#if storageAdapter}
	<div class="card">
		<div class="card-header">Open a Data Package</div>
		<div class="card-body space-y-4">
			<!-- <BackendSelect bind:value={storageAdapterSlug} /> -->
			<ProjectLoader {storageAdapter} projectFilter={{ onlyDataPackages: true }} let:projects>
				<ProjectSelector {projects} on:select={handleProjectSelect} selectButtonLabel="View" />
			</ProjectLoader>
		</div>
	</div>
{/if}
